﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

// See http://www.codeproject.com/Articles/6759/FOREACH-Vs-FOR-C

using System.Diagnostics;

namespace howto_time_loops_vs2015
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            Cursor = Cursors.WaitCursor;
            txtForEach.Clear();
            txtFor.Clear();
            txtWhile.Clear();
            txtForEach.Refresh();
            txtFor.Refresh();
            txtWhile.Refresh();

            int num_items = int.Parse(txtArraySize.Text);
            int num_trials = int.Parse(txtNumTrials.Text);
            int[] array = new int[num_items];
            int total = 0;
            Stopwatch watch = new Stopwatch();

            total = 0;
            watch.Start();
            for (int trial = 0; trial < num_trials; trial++)
            {
                foreach (int value in array)
                {
                    total += value;
                }
            }
            watch.Stop();
            txtForEach.Text = watch.Elapsed.TotalSeconds.ToString("0.00");
            txtForEach.Refresh();

            total = 0;
            watch.Reset();
            watch.Start();
            for (int trial = 0; trial < num_trials; trial++)
            {
                for (int i = 0; i < num_items; i++)
                {
                    total += array[i];
                }
            }
            watch.Stop();
            txtFor.Text = watch.Elapsed.TotalSeconds.ToString("0.00");
            txtFor.Refresh();

            total = 0;
            watch.Reset();
            watch.Start();
            for (int trial = 0; trial < num_trials; trial++)
            {
                int i = 0;
                while (i < num_items)
                {
                    total += array[i++];
                }
            }
            watch.Stop();
            txtWhile.Text = watch.Elapsed.TotalSeconds.ToString("0.00");
            txtWhile.Refresh();

            Cursor = Cursors.Default;
        }
    }
}
